Attribute VB_Name = "Module1"
Public PathToElcutFile As String
Public elc As ELCUT.Application
Public prb As ELCUT.Problem
Public mdl As ELCUT.Model
Public res As ELCUT.Result
Public Wnd As ELCUT.FieldWindow
Public Cnt As ELCUT.Contour
Public Coords As ELCUT.Point
Public T_Coords As ELCUT.FieldPoint
' API      Command.com
Declare Function GetSystemDirectory Lib "kernel32.dll" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
' 
Public Function Solve_Problem() As Byte
',     ,   -   
If prb.CanSolve Then prb.SolveProblem
',   ,   -   
If prb.Solved Then prb.AnalyzeResults
Set res = prb.Result
',    ,   -   0,   1
If res Is Nothing Then Solve_Problem = 0 Else Solve_Problem = 1
End Function
'       
'    
Function Mesh(step As Double)
    With mdl.Shapes '  :
    .RemoveMesh     '   
    .LabeledAs(Vertex:="Corner").Spacing = step '     Corner
    .BuildMesh      '   
End With
End Function
'      
's- ,     ,
'StepX -    X, StepY -    Y,
'MinX -   X- , MinY -   Y- 
'MaxX -   X- , MaxY -   Y- 
Public Function PRGrid(s As String, StepX As Double, StepY As Double, MinX As Double, MaxX As Double, MinY As Double, MaxY As Double)
'  X  Y- 
Dim CurrentX As Double, CurrentY As Double
'    
Open PathToElcutFile & s For Output As #1
'  Y-   
CurrentY = MinY
'   Y-    
Do While CurrentY <= MaxY
'  X-   
   CurrentX = MinX
'   X-    
   Do While CurrentX <= MaxX
'    
      Set Coords = elc.PointXY(CurrentX, CurrentY)
'      
      Set T_Coords = res.GetLocalValues(Coords)
'    ,     
      Write #1, Coords.X, Coords.Y, T_Coords.Potential, T_Coords.KGrad.X, T_Coords.KGrad.Y
'   X-     X
      CurrentX = CurrentX + StepX
' 
   Loop
'   Y-     Y
   CurrentY = CurrentY + StepY
' 
Loop
' 
Close #1
End Function

'       
'Nodes_file -  ,   Mod2Txt.exe,
'      -,
'T_Nodes_file -  ,     
Public Function FEGrid(Nodes_file As String, T_Nodes_file As String) As Long
Dim RetVal
Dim s As String
Dim x1 As Double, y1 As Double
Dim i, l1 As Integer

'  Windows
Dim system_dir As String
Dim length As Long

system_dir = Space(255)
length = GetSystemDirectory(system_dir, Len(system_dir))
    
Dim action_string As String
'  Mod2Txt.exe       -
action_string = Left$(system_dir, length) & "\COMMAND.COM /C " & PathToElcutFile & "\Mod2Txt.exe " & PathToElcutFile & "\Teplo1_1.mod > " & PathToElcutFile & Nodes_file
RetVal = Shell(action_string)
If RetVal = 0 Then Call MsgBox(" ")
' 10   ,   Mod2Txt.exe  
PauseTime = 10:
Start = Timer
Do While Timer < Start + PauseTime: DoEvents: Loop
'     -  
Open PathToElcutFile & Nodes_file For Input Access Read As #2
'    
Open PathToElcutFile & T_Nodes_file For Output As #1
'    -  
i = 0
Dim Pos1 As Integer
'     -
  Do
    Input #2, s
    Pos1 = InStr(1, Trim(s), " ", vbTextCompare)
':      Nodes_file   -
    If Pos1 < 1 Or _
       InStr(1, Trim(Mid(s, Pos1)), " ", vbTextCompare) > 1 _
    Then
      Exit Do
    End If
    x1 = Val(Trim(Left(s, Pos1 - 1)))
    y1 = Val(Trim(Mid(s, Pos1)))
'   
    i = i + 1
    Form1.Label1.Caption = "  " & CStr(i)
    DoEvents
'    
    Set Coords = elc.PointXY(x1, y1)
'      
    Set T_Coords = res.GetLocalValues(Coords)
'    ,     
    Write #1, Coords.X, Coords.Y, T_Coords.Potential, T_Coords.KGrad.X, T_Coords.KGrad.Y
' 
  Loop
'   
Close #1
'    
Close #2
'    -
FEGrid = i
End Function

